@Echo Off

:ParamSetting
Set Today=1500807
Set TargetNumber=0104
Set Project=NTC

:CommandSetting
Set MirCmd=Robocopy /R:0 /W:0 /MIR
Set TouchCmd=Touch -t %Today%%TargetNumber%
Set ArchiveCmd=7za.exe a -tzip -y -r -ssw -mx=9 -mpass=5
Set RmCmd=rm -f

:Initialize
Set DistributionZip=%Project%_%TargetNumber%.zip
Set DistributionZip64=%Project%64_%TargetNumber%.zip
Set SourceZip=%Project%_%TargetNumber%s.zip
Set NotExistFlag=false

:MoveToSolutionRoot
@ChDir /D "%~dp0"

:CheckDistributionZip
If Not Exist release\%DistributionZip% GoTo CheckDistributionZip64
Set NotExistFlag=true
Echo zzZIP͊ɂ܂Frelease\%DistributionZip%

:CheckDistributionZip64
If Not Exist release\%DistributionZip64% GoTo CheckSourceZip
Set NotExistFlag=true
Echo zz64bit ZIP͊ɂ܂Frelease\%DistributionZip64%

:CheckSourceZip
If Not Exist release\%SourceZip% GoTo CheckFlag
Set NotExistFlag=true
Echo \[XZIP͊ɂ܂Frelease\%SourceZip%

:CheckFlag
If "%NotExistFlag%"=="false" GoTo MakeDistributionZip
Set /P InKey=  ㏑܂HiY^nj
If /I "%InKey%"==""    GoTo MakeDistributionZip
If /I "%InKey%"=="Y"   GoTo MakeDistributionZip
If /I "%InKey%"=="YES" GoTo MakeDistributionZip
GoTo End

:MakeDistributionZip
PushD release\Win32
%RmCmd%      ../%DistributionZip%
%TouchCmd%   *.*
%ArchiveCmd% ..\%DistributionZip% *.*
PopD

:MakeDistributionZip64
PushD release\x64
%RmCmd%      ../%DistributionZip64%
%TouchCmd%   *.*
%ArchiveCmd% ..\%DistributionZip64% *.*
PopD

:MakeSourceZip
%MirCmd%   source  release\source\source
%TouchCmd%         release/source/source/*.*
%MirCmd%   project release\source\project /XF *.vcxproj.user
%TouchCmd%         release/source/project/*.*
%MirCmd%   .       release\source /XD *.* /XF *.sdf *.suo
%TouchCmd%         release/source/*.*
PushD release\source
%RmCmd%  ../%SourceZip%
%ArchiveCmd% ..\%SourceZip% *.*
PopD
%TouchCmd%         release/*.zip

:ShowFolder
Explorer /e,release

:End
