/*********************************************************************
 * clsSHA1.h
 *     SHA1 nbVNX
 *     made in the light of RFC3174
 * Author
 *     "ĂƁ" <tategoto@harpy.jp>
 * Updated
 *     2011/10/21
 *********************************************************************/


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

//////////// dCN[h}~ ////////////

#ifndef  _INC_CLSSHA1_
#define  _INC_CLSSHA1_


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////  wb_[CN[h ////////////

#include  <windows.h>


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

////////////  萔` ////////////

#define  SHA1HashSize  20


////////////  Ǝ^` ////////////

typedef  DWORD  uint32_t;
typedef  BYTE   uint8_t;
typedef  int    int_least16_t;


////////////  SHA1 nbVNX錾 ////////////

class  cls_SHA1
{
	public:
		cls_SHA1();  // RXgN^

	public:
		void    Reset();                                  // Ԃɂ
		void    InputMessage(LPBYTE Message, DWORD Len);  // bZ[W͂
		LPSTR   GetHash(LPSTR buf);                       // ͂bZ[WnbV𓾂 (ASCII)
		LPWSTR  GetHash(LPWSTR buf);                      // ͂bZ[WnbV𓾂 (UNICODE)

	public:
		typedef struct
		{
			uint32_t  Intermediate_Hash[SHA1HashSize / 4];  /* Message Digest */

			uint32_t  Length_Low;   /* Message length in bits */
			uint32_t  Length_High;  /* Message length in bits */

			int_least16_t  Message_Block_Index;  /* Index into message block array */
			uint8_t        Message_Block[64];    /* 512-bit message blocks         */

			int  Computed;   /* Is the digest computed?          */
			int  Corrupted;  /* Is the message digest corrupted? */
		}  SHA1Context;

	private:
		SHA1Context  Current;  // ͏
};


//////////// dCN[h}~I ////////////

#endif// _INC_CLSSHA1_


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
